#!/usr/local/bin/ruby
#
# converted from Info Manual
#                Sample drawings in C
#
# ./test01.rb > test01.ps

require "libplot"

MAXORDER = 12

def draw_c_curve(plotter, dx, dy, order)
  if order >= MAXORDER
	plotter.fcontrel(dx, dy)
  else
 	draw_c_curve(plotter, 0.5 * (dx - dy), 0.5 * (dx + dy), order + 1)
  	draw_c_curve (plotter, 0.5 * (dx + dy), 0.5 * (dy - dx), order + 1)
  end
end

plotter_params = Libplot::PlotterParams.new()
plotter_params.setplparam("PAGESIZE", "letter")

plotter = Libplot::Plotter.new("ps", STDIN, STDOUT, STDERR, plotter_params)
if plotter == nil
  STDERR.print "Couldn't create Plotter\n"
  exit 1
end

if plotter.openpl() < 0
  STDERR.print "Couldn't open Plotter\n"
  exit 1
end

plotter.fspace(0.0, 0.0, 1000.0, 1000.0)
plotter.flinewidth(0.25)
plotter.pencolorname("red")
plotter.erase()
plotter.fmove(600.0, 300.0)
draw_c_curve(plotter, 0.0, 400.0, 0)

if plotter.closepl() < 0
  STDERR.print "Couldn't close Plotter\n"
  exit 1
end

#if plotter.deletepl() < 0
#  STDERR.print "Couldn't delete Plotter\n"
#  exit 1
#end
